<?php
// POS command: Do not modify
// Includes
include_once 'PHPLibraries/GlobalFunctions.php';

function DBDecodeProductPropertyValues($TempData)
{
	$TempReturn = array();
	
	$TempItemArray = DecodeMessage($TempData);
	
	for ($t = 0; $t < count($TempItemArray); $t++)
	{
		$TempDecodedItem = DecodeMessage($TempItemArray[$t]);
		
		$TempItem = array();
		
		for ($x = 0; $x < count($TempDecodedItem); $x++)
		{

			switch ($TempDecodedItem[$x])
			{

			case 'Name':
				$TempItem['Name'] = DecodeMessage($TempDecodedItem[$x+1]);
				// $TempItem['Name'] = GetStringListItemWithZeroFallBack($TempItem['Name'], $TempTongue);
				$x++;
				break;

			default:
				$TempItem[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
				$x++;
				break;
				
			}

		}
		
		$TempReturn[$t] = $TempItem;

	}
	
	return $TempReturn;
}

function DBDecodeProductPrice($TempData)
{
	
	$TempReturn = array();
	
	
	$TempDecodedItem = DecodeMessage($TempData);
	
	$TempItem = array();
	
	for ($x = 0; $x < count($TempDecodedItem); $x++)
	{
		switch ($TempDecodedItem[$x])
		{
		case 'Bundles':
			$TempItem['Bundles'] = DBDecodeProductBundles($TempDecodedItem[$x+1]);
			$x++;
			break;
			
		case 'Discount':
			$TempItem['Discount'] = DBDecodeProductDiscount($TempDecodedItem[$x+1]);
			$x++;
			break;
			
		default:
			$TempItem[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
			$x++;
			break;
			
		}

	}
	
	$TempReturn = $TempItem;
	
	return $TempReturn;
}

function DBDecodeProductDiscount($TempData)
{
	
	$TempReturn = array();
	
	$TempDecodedItem = DecodeMessage($TempData);
	
	$TempItem = array();
	
	for ($x = 0; $x < count($TempDecodedItem); $x++)
	{
		switch ($TempDecodedItem[$x])
		{
		default:
			$TempItem[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
			$x++;
			break;
			
		}

	}
	
	$TempReturn = $TempItem;
	
	return $TempReturn;
}

function DBDecodeProductBundles($TempData, $TempTongue)
{
	$TempReturn = array();
	
	$TempItemArray = DecodeMessage($TempData);
	
	for ($t = 0; $t < count($TempItemArray); $t++)
	{
		
		$TempDecodedItem = DecodeMessage($TempItemArray[$t]);
		
		$TempItem = array();
		
		for ($x = 0; $x < count($TempDecodedItem); $x++)
		{

			switch ($TempDecodedItem[$x])
			{
			case 'Name':
				$TempItem['Name'] = DecodeMessage($TempDecodedItem[$x+1]);
				// $TempItem['Name'] = GetStringListItemWithZeroFallBack($TempItem['Name'], $TempTongue);
				$x++;
				break;
				
			case 'Price':
				$TempItem['Price'] = DBDecodeProductPrice($TempDecodedItem[$x+1]);
				$x++;
				break;
				
			case 'Dimensions':
				$TempItem['Dimensions'] = DBDecodeDimensionsData($TempDecodedItem[$x+1]);
				$x++;
				break;

			default:
				$TempItem[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
				$x++;
				break;
				
			}

		}
		
		$TempReturn[$t] = $TempItem;

	}
	
	return $TempReturn;
}

function DBDecodeShippingData($TempData, $TempTongue)
{
	
	$TempReturn = array();
	
	$TempItemArray = DecodeMessage($TempData);
	
	for ($t = 0; $t < count($TempItemArray); $t++)
	{
		
		switch ($TempItemArray[$t])
		{
		case 'Locations':
			$TempItem['Locations'] = DBDecodeShippingLocationsData($TempItemArray[$t+1], $TempTongue);
			$t++;
			break;
			
			
		default:
			$TempItem[$TempItemArray[$t]] = $TempItemArray[$t+1];
			$t++;
			break;
			
		}
		
		$TempReturn = $TempItem;
		
	}

	return $TempReturn;
}

function DBDecodeShippingLocationsData($TempLocationData, $TempTongue)
{
	
	$TempReturn = array();
	
	$TempLocationsArray = DecodeMessage($TempLocationData);
	
	for ($t = 0; $t < count($TempLocationsArray); $t++)
	{

		$TempLocationData = DecodeMessage($TempLocationsArray[$t]);
		
		$TempLocation = array();
		
		for ($x = 0; $x < count($TempLocationData); $x++)
		{
			
			switch ($TempLocationData[$x])
			{
			case 'Name':
				$TempLocation['Name'] = DecodeMessage($TempLocationData[$x+1]);
				$TempLocation['Name'] = GetStringListItemWithZeroFallBack($TempLocation['Name'], $TempTongue);
				$x++;
				break;
				
			case 'Taxes':
				$TempLocation['Taxes'] = DBDecodeTaxesData($TempLocationData[$x+1], $TempTongue);
				$x++;
				break;
				
			case 'Rates':
				$TempLocation['Rates'] = DBDecodeRatesData($TempLocationData[$x+1]);
				$x++;
				break;

			default:
				$TempLocation[$TempLocationData[$x]] = $TempLocationData[$x+1];
				$x++;
				break;
				
			}
			
		}
		
		$TempReturn[$t] = $TempLocation;
		
	}

	return $TempReturn;

}

function DBDecodeRatesData($TempData)
{
	$TempReturn = array();
	
	$TempItemArray = DecodeMessage($TempData);
	
	for ($t = 0; $t < count($TempItemArray); $t++)
	{
		
		$TempDecodedItem = DecodeMessage($TempItemArray[$t]);
		
		$TempItem = array();
		
		for ($x = 0; $x < count($TempDecodedItem); $x++)
		{
			switch ($TempDecodedItem[$x])
			{
			case 'Box':
				$TempItem['Box'] = DBDecodeBoxData($TempDecodedItem[$x+1]);
				$x++;
				break;

			case 'ShippingService':
				$TempItem['ShippingService'] = DBDecodeShippingServiceData($TempDecodedItem[$x+1]);
				$x++;
				break;
				
			default:
				$TempItem[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
				$x++;
				break;
				
			}

		}
		
		$TempReturn[$t] = $TempItem;

	}
	
	return $TempReturn;

}

function DBDecodeTaxesData($TempTaxData, $TempTongue)
{
	
	$TempReturn = array();
	
	$TempTaxArray = DecodeMessage($TempTaxData);
	
	for ($t = 0; $t < count($TempTaxArray); $t++)
	{
		
		$TempDecodedItem = DecodeMessage($TempTaxArray[$t]);
		
		$TempTax = array();
		
		for ($x = 0; $x < count($TempDecodedItem); $x++)
		{
			switch ($TempDecodedItem[$x])
			{
			case 'Name':
				$TempTax['Name'] = DecodeMessage($TempDecodedItem[$x+1]);
				$TempTax['Name'] = GetStringListItemWithZeroFallBack($TempTax['Name'], $TempTongue);
				$x++;
				break;
				
			case 'ExcludedProductsByProperties':
				$TempTax['ExcludedProductsByProperties'] = DBDecodeExcludedProductsByPropertiesData($TempDecodedItem[$x+1]);
				$x++;
				break;
				
				
			default:
				$TempTax[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
				$x++;
				break;
				
			}

		}
		
		$TempReturn[$t] = $TempTax;

	}
	
	return $TempReturn;

}

function DBDecodeExcludedProductsByPropertiesData($TempData)
{
	
	$TempReturn = array();
	
	$TempItemArray = DecodeMessage($TempData);
	
	for ($t = 0; $t < count($TempItemArray); $t++)
	{
		
		$TempDecodedItem = DecodeMessage($TempItemArray[$t]);
		
		$TempItem = array();
		
		for ($x = 0; $x < count($TempDecodedItem); $x++)
		{
			switch ($TempDecodedItem[$x])
			{
			case 'Name':
				$TempItem['Name'] = DecodeMessage($TempDecodedItem[$x+1]);
				$TempItem['Name'] = $TempItem['Name'][0];
				$x++;
				break;
				
			default:
				$TempItem[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
				$x++;
				break;
				
			}

		}
		
		$TempReturn[$t] = $TempItem;

	}
	
	return $TempReturn;

}

function DBDecodeBoxData($TempData)
{
	
	$TempReturn = array();
	
	$TempItemArray = DecodeMessage($TempData);

	$TempDecodedItem = $TempItemArray;
	
	$TempItem = array();
	
	for ($x = 0; $x < count($TempDecodedItem); $x++)
	{
		switch ($TempDecodedItem[$x])
		{
		case 'Dimensions':
			$TempItem['Dimensions'] = DBDecodeDimensionsData($TempDecodedItem[$x+1]);
			$x++;
			break;
			
		default:
			$TempItem[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
			$x++;
			break;
			
		}

	}
	
	$TempReturn = $TempItem;

	return $TempReturn;

}

function DBDecodeDimensionsData($TempData)
{
	
	$TempReturn = array();
	
	$TempItemArray = DecodeMessage($TempData);
	
	$TempDecodedItem = $TempItemArray;
	
	$TempItem = array();
	
	for ($x = 0; $x < count($TempDecodedItem); $x++)
	{
		switch ($TempDecodedItem[$x])
		{
			
		default:
			$TempItem[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
			$x++;
			break;
			
		}

	}
	
	$TempReturn = $TempItem;

	return $TempReturn;

}

function DBDecodeShippingServiceData($TempData)
{
	
	$TempReturn = array();
	
	$TempItemArray = DecodeMessage($TempData);

	$TempDecodedItem = $TempItemArray;
	
	$TempItem = array();
	
	for ($x = 0; $x < count($TempDecodedItem); $x++)
	{
		switch ($TempDecodedItem[$x])
		{
		case 'Name':
			$TempItem['Name'] = DecodeMessage($TempDecodedItem[$x+1]);
			$x++;
			break;
			
		default:
			$TempItem[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
			$x++;
			break;
			
		}

	}
	
	$TempReturn = $TempItem;

	return $TempReturn;

}

function DBDecodeCouponsData($TempData)
{
	$TempReturn = array();
	
	$TempDecodedItem = DecodeMessage($TempData);
	
	for ($x = 0; $x < count($TempDecodedItem); $x++)
	{
		$TempReturn[] = DBDecodeCouponData($TempDecodedItem[$x]);
	}
	
	return $TempReturn;
}

function DBDecodeCouponData($TempData)
{
	
	$TempReturn = array();
	
	$TempDecodedItem = DecodeMessage($TempData);
	
	$TempItem = array();
	
	for ($x = 0; $x < count($TempDecodedItem); $x++)
	{
		switch ($TempDecodedItem[$x])
		{
		default:
			$TempItem[$TempDecodedItem[$x]] = $TempDecodedItem[$x+1];
			$x++;
			break;
			
		}

	}
	
	if (array_key_exists('ExpirationDate', $TempItem))
	{
		$TempItem['ExpirationDate'] = strtotime($TempItem['ExpirationDate']);
	}

	if ($TempItem['IsPercentage'] == '0')
	{
		$TempItem['IsPercentage'] = false;
	}
	else
	{
		$TempItem['IsPercentage'] = true;
	}
	
	$TempReturn = $TempItem;
	
	return $TempReturn;
}

?>